(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["immutable-http"] = factory();
	else
		root["immutable-http"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	var _validate = __webpack_require__(1);
	
	var _validate2 = _interopRequireDefault(_validate);
	
	var _url2 = __webpack_require__(3);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var identity = function identity(x) {
	  return x;
	};
	
	var defaultParams = {
	  executor: null,
	  url: null,
	  method: null,
	  headers: [],
	  body: null,
	  responseType: null,
	  dynamicSegments: [],
	  queryParams: [],
	  bodyProcessor: identity,
	  responseProcessor: identity
	};
	
	var Internals = function Internals(params) {
	  var _this = this;
	
	  _classCallCheck(this, Internals);
	
	  Object.entries(params).map(function (_ref) {
	    var _ref2 = _slicedToArray(_ref, 2);
	
	    var key = _ref2[0];
	    var value = _ref2[1];
	    return Object.defineProperty(_this, key, {
	      get: function get() {
	        return value;
	      },
	      enumerable: true,
	      configurable: true
	    });
	  });
	};
	
	/**
	 * @typedef {[key: string, value: string]} Tuple
	 */
	
	/**
	 * @typedef {Object} HttpRequestParams
	 * @property {string} url resource url
	 * @property {string} method HTTP method,
	 * @property {Tuple[]} headers array of HTTP headers key-value pairs
	 * @property {Object} body request payload
	 * @property {string} responseType response type
	 * @property {Tuple[]} dynamicSegments key-value array of replacements for the provided url
	 * @property {Tuple[]} queryParams key-value array of url params
	 * @property {function(x: Object): Object} bodyProcessor map body function
	 * @property {function(x: Object): Object} responseProcessor map response function
	 * @property {function(url: string, method: string, headers: string[], responseType: string, body: Object): Promise} executor performs HTTP request and returns Promise,
	 */
	
	// executor: function(url: string, method: string, headers: string[], responseType: string, body: Object): Promise,
	// bodyProcessor: function(x: Object): Object, responseProcessor: function(x: Object): Object
	
	/**
	 * Http request object.
	 * Expose chainable API
	 */
	
	
	var Http = function () {
	
	  /**
	   * @param {HttpRequestParams} params - HTTP request params
	   */
	
	  function Http() {
	    var params = arguments.length <= 0 || arguments[0] === undefined ? defaultParams : arguments[0];
	
	    _classCallCheck(this, Http);
	
	    var internals = new Internals(params);
	    this.internals = function () {
	      return internals;
	    };
	  }
	
	  /**
	   * Set the middleware that will perform the request
	   * @param {function(url: string, method: string, headers: string[], responseType: string, body: Object): Promise} executor -
	   * function which performs the request asynchroniously and returns Promise back
	   * @returns {Object} Http object
	   */
	
	
	  _createClass(Http, [{
	    key: 'executor',
	    value: function executor(_executor) {
	      return new Http(Object.assign({}, this.internals(), { executor: _executor }));
	    }
	
	    /**
	     * Adds URL information to HTTP request model
	     * @param {string} url - URL
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'url',
	    value: function url(_url) {
	      return new Http(Object.assign({}, this.internals(), { url: _url }));
	    }
	
	    /**
	     * Adds HTTP method information to request model
	     * @param {string} method - HTTP method
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'method',
	    value: function method(_method) {
	      return new Http(Object.assign({}, this.internals(), { method: _method }));
	    }
	
	    /**
	     * Adds header to request model
	     * @param {string} header - valid header key
	     * @param {string} value - valid header value
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'header',
	    value: function header(_header, value) {
	      var headers = this.internals().headers.concat([[_header, value]]);
	      return new Http(Object.assign({}, this.internals(), { headers: headers }));
	    }
	
	    /**
	     * Adds body to request model
	     * @param {Object} body - request payload
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'body',
	    value: function body(_body) {
	      return new Http(Object.assign({}, this.internals(), { body: _body }));
	    }
	
	    /**
	     * Sets response content type
	     * Proper values could be obtained form XmlHttpRequest specification
	     * https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest#Properties
	     * @param {string} responseType - Proper values could be obtained form
	     * XmlHttpRequest specification
	     * https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest#Properties
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'responseType',
	    value: function responseType(_responseType) {
	      return new Http(Object.assign({}, this.internals(), { responseType: _responseType }));
	    }
	
	    /**
	     * Adds dynamic segment value
	     * @param {string} segment - segment key
	     * @param {string} value - segment value
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'segment',
	    value: function segment(_segment, value) {
	      var dynamicSegments = this.internals().dynamicSegments.concat([[_segment, value]]);
	      return new Http(Object.assign({}, this.internals(), { dynamicSegments: dynamicSegments }));
	    }
	
	    /**
	     * Adds query string param
	     * @param {string} name - param key
	     * @param {string} value - param value
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'query',
	    value: function query(name, value) {
	      var queryParams = this.internals().queryParams.concat([[name, value]]);
	      return new Http(Object.assign({}, this.internals(), { queryParams: queryParams }));
	    }
	
	    /**
	     * Sets the function which gets the body object as a parameter
	     * which result would be used as a request body
	     * @param {func} bodyProcessor - f(x) => valid_http_body
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'bodyProcessor',
	    value: function bodyProcessor(_bodyProcessor) {
	      return new Http(Object.assign({}, this.internals(), { bodyProcessor: _bodyProcessor }));
	    }
	
	    /**
	     * Sets the function which gets the response and produces another value
	     * Useful for default HTTP error handling
	     *
	     * @example
	     * response => {
	     *  switch(response.code) {
	     *    case "404":
	     *      return { message: 'Resource not found' }
	     *  }
	     *}
	     *
	     * @param {func} responseProcessor - f(x) => y
	     * @returns {Object} Http object
	     */
	
	  }, {
	    key: 'responseProcessor',
	    value: function responseProcessor(_responseProcessor) {
	      return new Http(Object.assign({}, this.internals(), { responseProcessor: _responseProcessor }));
	    }
	
	    /**
	     * Executes HTTP request
	     * @returns {Object} - Promise
	     */
	
	  }, {
	    key: 'exec',
	    value: function exec() {
	      var _internals = this.internals();
	
	      var url = _internals.url;
	      var method = _internals.method;
	      var headers = _internals.headers;
	      var responseType = _internals.responseType;
	      var dynamicSegments = _internals.dynamicSegments;
	      var queryParams = _internals.queryParams;
	      var body = _internals.body;
	      var bodyProcessor = _internals.bodyProcessor;
	      var responseProcessor = _internals.responseProcessor;
	      var executor = _internals.executor;
	
	      if (!executor) {
	        throw new Error('executor was not set');
	      }
	      var errors = (0, _validate2.default)(url, method, headers, responseType);
	      if (errors.length !== 0) throw new Error(errors.join('\n'));
	      var urlWithDynamicSegments = (0, _url2.mixinDynamicSegmentsValues)(url, dynamicSegments);
	      var fullUrl = (0, _url2.addQueryParams)(urlWithDynamicSegments, queryParams);
	      return executor(fullUrl, method, headers, responseType, bodyProcessor(body)).then(responseProcessor);
	    }
	  }]);
	
	  return Http;
	}();

	exports.default = Http;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	var _option = __webpack_require__(2);
	
	var _option2 = _interopRequireDefault(_option);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var supportedMethods = ['GET', 'POST', 'PUT', 'DELETE'];
	var validTypes = [null, '', 'arraybuffer', 'blob', 'document', 'text', 'json'];
	
	/**
	 * Validate HTTP method
	 * @param {String} method – HTTP method
	 * @return {String} error
	 */
	function validateMethod(method) {
	  if (!method) {
	    return _option2.default.some('HTTP method is not specified');
	  }
	  if (typeof method !== 'string') {
	    return _option2.default.some('HTTP method should be type of string');
	  }
	  if (supportedMethods.indexOf(method.toUpperCase()) < 0) {
	    return _option2.default.some('Http method ' + method + ' is not supported');
	  }
	  return _option2.default.none;
	}
	
	/**
	 * Basicly validate url
	 * @param {String} url – URL
	 * @return {String} error
	 */
	function validateUrl(url) {
	  if (!url) {
	    return _option2.default.some('Url is not specified');
	  }
	  if (typeof url !== 'string') {
	    return _option2.default.some('Url should be type of string');
	  }
	  return _option2.default.none;
	}
	
	/**
	 * Validate header to all parts be strings
	 * @param {String} key – Header key
	 * @param {String} value – Header value
	 * @return {String} error
	 */
	function validateHeader(key, value) {
	  if (typeof key !== 'string' || typeof value !== 'string') return _option2.default.some('Parts of header ' + key + ':' + value + ' must be strings');
	  return _option2.default.none;
	}
	
	/**
	 * Validate headers
	 * @param {Object} headers – headers
	 * @return {Array} error
	 */
	function validateHeaders(headers) {
	  var aggr = [];
	  var _iteratorNormalCompletion = true;
	  var _didIteratorError = false;
	  var _iteratorError = undefined;
	
	  try {
	    for (var _iterator = headers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	      var _step$value = _slicedToArray(_step.value, 2);
	
	      var key = _step$value[0];
	      var value = _step$value[1];
	
	      aggr.push(validateHeader(key, value));
	    }
	  } catch (err) {
	    _didIteratorError = true;
	    _iteratorError = err;
	  } finally {
	    try {
	      if (!_iteratorNormalCompletion && _iterator.return) {
	        _iterator.return();
	      }
	    } finally {
	      if (_didIteratorError) {
	        throw _iteratorError;
	      }
	    }
	  }
	
	  return aggr;
	}
	
	/**
	 * Validates response type
	 * @param {string} type - response type
	 * @return {String} error
	 */
	function validateResponseType(type) {
	  if (validTypes.indexOf(type) < 0) return _option2.default.some('Response content type ' + type + ' is not supported');
	  return _option2.default.none;
	}
	
	/**
	 * @ignore
	 * Validate HTTP request model
	 * @param {String} url – url
	 * @param {String} method – HTTP method
	 * @param {Map} headers – HTTP headers
	 * @param {String} responseType – response type
	 * @return {Array} array of errors
	 */
	function validate(url, method, headers, responseType) {
	  return [validateUrl(url), validateMethod(method), validateResponseType(responseType)].concat(validateHeaders(headers)).filter(function (_) {
	    return _.isSome();
	  }).map(function (_) {
	    return _.value();
	  });
	}
	
	exports.default = validate;

/***/ },
/* 2 */
/***/ function(module, exports) {

	exports.none = Object.create({
	    value: function() {
	        throw new Error('Called value on none');
	    },
	    isNone: function() {
	        return true;
	    },
	    isSome: function() {
	        return false;
	    },
	    map: function() {
	        return exports.none;
	    },
	    flatMap: function() {
	        return exports.none;
	    },
	    toArray: function() {
	        return [];
	    },
	    orElse: callOrReturn,
	    valueOrElse: callOrReturn
	});
	
	function callOrReturn(value) {
	    if (typeof(value) == "function") {
	        return value();
	    } else {
	        return value;
	    }
	}
	
	exports.some = function(value) {
	    return new Some(value);
	};
	
	var Some = function(value) {
	    this._value = value;
	};
	
	Some.prototype.value = function() {
	    return this._value;
	};
	
	Some.prototype.isNone = function() {
	    return false;
	};
	
	Some.prototype.isSome = function() {
	    return true;
	};
	
	Some.prototype.map = function(func) {
	    return new Some(func(this._value));
	};
	
	Some.prototype.flatMap = function(func) {
	    return func(this._value);
	};
	
	Some.prototype.toArray = function() {
	    return [this._value];
	};
	
	Some.prototype.orElse = function(value) {
	    return this;
	};
	
	Some.prototype.valueOrElse = function(value) {
	    return this._value;
	};
	
	exports.isOption = function(value) {
	    return value === exports.none || value instanceof Some;
	};
	
	exports.fromNullable = function(value) {
	    if (value == null) {
	        return exports.none;
	    }
	    return new Some(value);
	}


/***/ },
/* 3 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	exports.mixinDynamicSegmentsValues = mixinDynamicSegmentsValues;
	exports.addQueryParams = addQueryParams;
	/**
	 * @ignore
	 * Mixins dynamic segments replacing the `:segment_name` parts with provide
	 * values
	 * @param {String} url – URL
	 * @param {Object} dynamicSegments – dynamic segments
	 * @returns {String} – URL
	 */
	function mixinDynamicSegmentsValues(url, dynamicSegments) {
	  return dynamicSegments.reduce(function (aggr, _ref) {
	    var _ref2 = _slicedToArray(_ref, 2);
	
	    var key = _ref2[0];
	    var value = _ref2[1];
	    return aggr.replace(':' + key, value);
	  }, url);
	}
	
	/**
	 * @ignore
	 * Adds query params string to url
	 * @param {string} url – URL
	 * @param {Array} queryParams – query params
	 * @returns {String} – URL
	 */
	function addQueryParams(url, queryParams) {
	  var chanks = queryParams.map(function (_ref3) {
	    var _ref4 = _slicedToArray(_ref3, 2);
	
	    var key = _ref4[0];
	    var value = _ref4[1];
	    return key + '=' + value;
	  });
	  return url + (chanks.length !== 0 ? '?' + chanks.join('&') : '');
	}

/***/ }
/******/ ])
});
;
//# sourceMappingURL=index.js.map